package jp.ne.ytp.collection.bean;

import java.util.Calendar;
import java.text.SimpleDateFormat;

/**
 * Ԃ̔グ
 * @author ytp
 */
public class FlowerSales implements Comparable {
    /**
     * Ԃ̖O
     */
    private String name_;
    
    /**
     * 
     */
    private Calendar date_;
    
    /**
     * 㐔
     */
    private int quantity_;
    
    /**
     * P
     */
    private int price_;
    
    /**
     * ftHgRXgN^
     */
    public FlowerSales() {
    }
    
    /**
     * w肳ꂽCX^X𐶐
     * @name Ԃ̖O
     * @date 
     * @quantity 㐔
     * @price P
     */
    public FlowerSales(String name, Calendar date, int quantity, int price) {
        setName(name);
        setDate(date);
        setQuantity(quantity);
        setPrice(price);
    }
    
    /**
     * Ԃ̖Oݒ肷
     * @param name Ԃ̖O
     */
    public void setName(String name) {
        name_ = name;
    }
    
    /**
     * Ԃ̖OԂ
     * @return Ԃ̖O
     */
    public String getName() {
        return name_;
    }
    
    /**
     * ݒ肷
     * @param date 
     */
    public void setDate(Calendar date) {
        date_ = date;
    }
    
    /**
     * Ԃ
     * @return 
     */
    public Calendar getDate() {
        return date_;
    }
    
    /**
     * 㐔ʂݒ肷
     * @param quantity 㐔
     */
    public void setQuantity(int quantity) {
        quantity_ = quantity;
    }
    
    /**
     * PԂ
     * @return P
     */
    public int getQuantity() {
        return quantity_;
    }
    
    /**
     * Pݒ肷
     * @param price P
     */
    public void setPrice(int price) {
        price_ = price;
    }
    
    /**
     * PԂ
     * @return P
     */
    public int getPrice() {
        return price_;
    }
    
    /**
     * zԂiʂƒP悶́j
     * @return z
     */
    public int getAmount() {
        return quantity_ * price_;
    }
    
    /**
     * ̃IuWFNg̉Ԃ̖OƔ(N)
     * otherŎw肳ꂽIuWFNgƔrA
     * ̌ʁieǂjԂ
     * @other rΏۂ̃IuWFNg
     * @return true: false:قȂ
     */
    public boolean equals(Object other) {
        // ΏۂFlowerSalesCX^X̏ꍇ
        if (other instanceof FlowerSales) {
            FlowerSales target = (FlowerSales)other;
            Calendar me = getDate();
            Calendar you = target.getDate();
            return (getName().equals(target.getName())
                 && me.get(Calendar.YEAR) == you.get(Calendar.YEAR)
                 && me.get(Calendar.MONTH) == you.get(Calendar.MONTH)
                 && me.get(Calendar.DATE) == you.get(Calendar.DATE)
            );
        } else {
            return false;
        }
    }
    
    /**
     * ̃IuWFNg̉Ԃ̖OƔ(N)
     * otherŎw肳ꂽIuWFNgƔrA
     * ̃IuWFNgw肳ꂽIuWFNg菬ꍇ͕̐A
     * ꍇ̓[A傫ꍇ͐̐Ԃ
     * @other rΏۂ̃IuWFNg
     * @return ̃IuWFNgw肳ꂽIuWFNg菬ꍇ͕̐A
     *         ꍇ̓[A傫ꍇ͐̐
     */
    public int compareTo(Object other) {
        FlowerSales target = (FlowerSales)other;
        Calendar you = target.getDate();
        Calendar me = getDate();
        // Nꍇ
        if (me.get(Calendar.YEAR) == you.get(Calendar.YEAR)) {
            // ꍇ
            if (me.get(Calendar.MONTH) == you.get(Calendar.MONTH)) {
                // ꍇ
                if (me.get(Calendar.DATE) == you.get(Calendar.DATE)) {
                    // N`܂ł̂ŁAԂ̖O̔rʂ̂܂ܕԂ
                    return getName().compareTo(target.getName());
                } else {
                    return me.get(Calendar.DATE) - you.get(Calendar.DATE);
                }
            } else {
                return me.get(Calendar.MONTH) - you.get(Calendar.MONTH);
            }
        } else {
            return me.get(Calendar.YEAR) - you.get(Calendar.YEAR);
        }
    }
    
    /**
     * equalsI[o[CĥŁAhashCodeI[o[
     * Ch
     * @return nbVR[h
     * @see java.lang.Object#hashCode()
     */
    public int hashCode() {
        SimpleDateFormat yyyymmdd = new SimpleDateFormat("yyyy/MM/dd");
        StringBuffer work = new StringBuffer();
        work.append(yyyymmdd.format(getDate().getTime()));
        work.append(" ").append(getName());
        return (work.toString().hashCode());
    }
    
    /**
     * CX^X̕\Ԃ
     * EԂ̖OE㐔ʁEPA
     * @return CX^X̕\
     */
    public String toString() {
        SimpleDateFormat yyyymmdd = new SimpleDateFormat("yyyy/MM/dd");
        StringBuffer work = new StringBuffer();
        work.append(yyyymmdd.format(getDate().getTime()));
        work.append(" ").append(getName());
        work.append(" ").append(getQuantity()).append("{");
        work.append(" ").append(getPrice()).append("~");
        
        return new String(work);
    }
}
