package jp.ne.ytp.collection.practice;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import jp.ne.ytp.collection.bean.FlowerSales;
import jp.ne.ytp.collection.reference.Tester;

/**
 *  List̕@mFNX
 */
public class CollectionsCopyTester extends Tester {
	Object[] data = new Object[] {
		ajisai,
		momo,
		sumire,
		bara
	};
	List list = null;

	/**
	 *  eXgs
	 *  @param args R}hCp[^
	 */
	public void test(String[] args) {
		// 
		if (args.length != 0 && args[0].equals("array")) {
			list = new ArrayList();
		} else {
			list = new LinkedList();
		}
		for (int i=0 ; i<data.length ; i++) {
			list.add(data[i]);
		}
		
		// clone()\bhɂRs[
		List clonedList = null;
		if (list instanceof ArrayList) {
			clonedList = (List) ((ArrayList)list).clone();
		} else {
			clonedList = (List) ((LinkedList)list).clone();
		}
		System.out.print("clone ... ");
		for (int i=0 ; i<data.length ; i++) {
			System.out.print("["+i+"]"+(data[i]==list.get(i))+" ");
		}
		System.out.println("");
		
		// RXgN^ɂRs[
		List copiedList = null;
		if (list instanceof ArrayList) {
			copiedList = new ArrayList(list);
		} else {
			copiedList = new LinkedList(list);
		}
		System.out.print("new "+ copiedList.getClass().getName()+"(list) ... ");
		for (int i=0 ; i<data.length ; i++) {
			System.out.print("["+i+"]"+(data[i]==copiedList.get(i))+" ");
		}
		System.out.println("");
		
		// Collections.copy()\bhɂRs[
		doCopy();
	}
	
	// Collections.copy()\bhɂRs[mF郁\bh
	private void doCopy() {
		System.out.println("Collections.copy ... ");

		List destList = null;
		if (list instanceof ArrayList) {
			/*
			 * ̕@ArrayList֗eʂmۂ邾Ȃ̂ŁA
			 * destList.size()̒l0ƂȂ
			 */
			destList = new ArrayList(list.size());
		} else {
			/*
			 * LinkedListł͏eʂ̊mۂƂTÔ
			 * Ȃ
			 */
			destList = new LinkedList();
		}
		/*
		 * 炩ߗvfǉdestList.size()\bh
		 * llist.size()\bh̒lȏƂȂ悤ɂĂB
		 * ̏sĂȂƁAcopy()\bh
		 * java.lang.IndexOutOfBoundsException𔭐ďI
		 * 
		 */
		Iterator iterator = list.iterator();
		while (iterator.hasNext()) {
			destList.add(new FlowerSales());
			iterator.next();
		}

		// Rs[
		Collections.copy(destList, list);

		// Rs[̊mF
		System.out.print("  copied:list.get(i)==destList.get(i)\n    ");
		for (int i=0 ; i<data.length ; i++) {
			System.out.print("["+i+"]"+(list.get(i)==destList.get(i))+" ");
		}
		System.out.println("");
	}

	/**
	 * C\bh
	 * @param args R}hCp[^
	 */
	public static void main(String[] args) {
		Tester tester = new CollectionsCopyTester();
		tester.test(args);
	}
}
