package jp.ne.ytp.collection.practice;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import jp.ne.ytp.collection.reference.Tester;

/**
 * Collections.rotate()\bh̓mFNX
 */
public class CollectionsRotateTester extends Tester {
    /**
     *  eXgs
     *  @param args R}hCp[^
     */
    public void test(String[] args) {
        String s = "Collections";
        List list = new ArrayList();
        for (int i=0 ; i<s.length() ; i++) {
            list.add(i, s.substring(i, i+1));
        }
        
        System.out.println("\nlist");
        showList(list);
        
        Collections.rotate(list, 1);
        System.out.println("\nCollections.rotate(list, 1)");
        showList(list);
        
        Collections.rotate(list, -12);
        System.out.println("\nCollections.rotate(list, -12)");
        showList(list);

        System.out.println("\nubN}[Nړ̗");
        System.out.println("  Collections.rotate(bookmarks.subList(4, 9), -1)");
        List bookmarks = Arrays.asList(new String[] {
            "http://www.ytp.ne.jp/",     // A
            "http://www.jajakarta.org/", // B
            "http://www.sssg.org/",      // C
            "http://www.sbpnet.jp/",     // D
            "http://www.goo.ne.jp/",     // E
            "http://www.google.co.jp/",  // F
            "http://www.amazon.co.jp/",  // G
            "http://www.yahoo.co.jp/",   // H
            "http://www.mapfan.com/",    // I
            "http://www.excite.co.jp/",  // J
            "http://weblogs.java.net/",  // K
        });
        List subList = bookmarks.subList(4, 9);
        System.out.println("ړOiŚj");
        showBookmarks(bookmarks);
        System.out.println("\nړOij");
        showBookmarks(subList);
        // ړ
        Collections.rotate(bookmarks.subList(4, 9), -1);
        System.out.println("\nړij");
        showBookmarks(subList);
        System.out.println("\nړiŚj");
        showBookmarks(bookmarks);
        System.out.println("");
    }
    
    private void showList(List list) {
        System.out.println("0 1 2 3 4 5 6 7 8 9 10");
        Iterator iterator = list.iterator();
        while (iterator.hasNext()) {
            System.out.print(iterator.next()+" ");
        }
        System.out.println("");
    }

    private void showBookmarks(List list) {
        Iterator iterator = list.iterator();
        int i=0;
        while (iterator.hasNext()) {
            System.out.println("\t["+i+"]:"+iterator.next());
            i++;
        }
    }

    /**
     * C\bh
     * @param args R}hCp[^
     */
    public static void main(String[] args) {
        Tester tester = new CollectionsRotateTester();
        tester.prepare();
        tester.test(args);
    }
}
