package jp.ne.ytp.collection.practice;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import jp.ne.ytp.collection.reference.Tester;

/**
 * L[NX̎mFNX
 */
public class QueueTester extends Tester {
	/**
	 * L[NX̎
	 */
	class Queue {
		private List queue;
		public Queue(List list) {
			queue = list;
		}
		public boolean isEmpty() {
			return queue.isEmpty();
		}
		public void enqueue(Object value) {
			queue.add(value);
		}
		public Object dequeue() {
			Object ret;
			if (queue.isEmpty()) {
				return null;
			}
			ret = queue.get(0);
			queue.remove(0);
			return ret;
		}
	}

	/**
	 *  eXgs
	 *  @param args R}hCp[^
	 */
	public void test(String[] args) {
		System.out.println("Queue(LinkedList):-------------------");
		Queue queue = new Queue(new LinkedList());
		testQueue(queue);
		System.out.println("Queue(ArrayList) :-------------------");
		queue = new Queue(new ArrayList());
		testQueue(queue);
	}
	
	private void testQueue(Queue queue) {
		queue.enqueue(sumire);
		queue.enqueue(bara);
		queue.enqueue(ajisai);
		System.out.println(queue.dequeue()); // sumire
		System.out.println(queue.dequeue()); // bara
		queue.enqueue(momo);
		System.out.println(queue.dequeue()); // ajisai
		System.out.println(queue.dequeue()); // momo
	}
    
	/**
	 * C\bh
	 * @param args R}hCp[^
	 */
	public static void main(String[] args) {
		Tester tester = new QueueTester();
		tester.prepare();
		tester.test(args);
	}
}