package jp.ne.ytp.collection.practice;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *  feL̃NX
 */
public class Article {
    /**
     *  L̔ԍ
     */
    private int articleNo_;
     
    /**
     *  ԐML̏ꍇ̐eL̔ԍ
     */
    private int sourceNo_;
     
    /**
     *  ԐML̏ꍇ̃XbhL̔ԍ
     */
    private int rootNo_;
     
    /**
     *  L̓eҖ
     */
    private String author_;
     
    /**
     *  L̖{
     */
    private String text_;
     
    /**
     *  ̋Lɑ΂ԐML
     */
    private List responses_ = new ArrayList();
     
    /**
     *  Ŏw肳ꂽlLCX^X𐶐
     *  @param articleNo Lԍ
     *  @param author eҖ
     *  @param text {
     */
    public Article(int articleNo, String author, String text) {
        this(articleNo, author, text, articleNo, 0);
     }
     
    /**
     *  Ŏw肳ꂽlԐMLCX^X𐶐
     *  @param articleNo Lԍ
     *  @param author eҖ
     *  @param text {
     *  @param rootNo XbhLԍ
     *  @param sourceNo eLԍ
     */
    public Article(int articleNo, String author, String text
     , int rootNo, int sourceNo) {
        articleNo_ = articleNo;
        author_ = author;
        text_ = text;
        rootNo_ = rootNo;
        sourceNo_ = sourceNo;
    }
     
    /**
     *  LԍԂ
     *  @return Lԍ
     */
    public int getArticleNo() {
        return articleNo_;
    }
     
    /**
     *  e̋LԍԂ
     *  @return e̋Lԍ
     */
    public int getSourceNo() {
        return sourceNo_;
    }
     
    /**
     *  Xbh̋LԍԂ
     *  @return Xbh̋Lԍ
     */
    public int getRootNo() {
        return rootNo_;
    }
     
    /**
     *  L̓eҖԂ
     *  @return L̓eҖ
     */
    public String getAuthor() {
        return author_;
    }
     
    /**
     *  L̖{Ԃ
     *  @return L̖{
     */
    public String getText() {
        return text_;
    }
     
    /**
     *  ̋L̕ԐMLݒ肷
     *  @return ԐML
     */
    public void reply(Article response) {
        responses_.add(response);
    }
     
    /**
     *  targetŎw肳ꂽLԍLԂ
     *  @param target Lԍ
     *  @return L
     */
    public Article find(int target) {
        // gΏۂł
        if (target == articleNo_) {
            return this;
        }
        
        Article source = null;
        Iterator children = responses_.iterator();
        
        // z̋L
        while (children.hasNext()) {
            Article child = (Article)children.next();
            source = child.find(target);
            // Ώۂ̋L
            if (source != null) {
                break;
            }
        }
        
        return source;
    }
    
    /**
     *  L̕\Ԃ
     *  @return L̕\
     */
    public String toString() {
        return articleNo_ + ". " + text_ + " e[" + author_ + "]";
    }
    
    /**
     *  ̋LƔz̕ԐMLׂĕ\
     *  @param layer L̊Kw
     */
    public void show(int layer) {
        System.out.println(indent(layer) + toString());
        Iterator children = responses_.iterator();
        
        // gԐMLׂĕ\
        while (children.hasNext()) {
            Article child = (Article)children.next();
            child.show(layer + 1);
        }
    }
    
    /**
     *  layerŎw肳ꂽKw̃Cfgp󔒂Ԃ
     *  @param layer Cfg̊Kw
     *  @return Cfgp󔒕
     */
    private String indent(int layer) {
        StringBuffer indent = new StringBuffer();
        for (int i = 0; i < layer; i++) {
            indent.append("    ");
        }
        
        return new String(indent);
    }
}
