package jp.ne.ytp.collection.practice;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

/**
 * XML`ō쐬ꂽinit@Cǂݍ݁A
 * ̒lێNX
 * @author YTP
 */
public class IniFile extends DefaultHandler {
    /**
     * init@C̃pX
     */
    private String iniPath_;
    
    /**
     * init@C̑SZNVvfێ
     */
    private Map root_ = new HashMap();
    
    // ȉ̓[N
    private String current_;
    private String entryName_;
    private Map section_;
    private StringBuffer entryValue_;
    
    /**
     * iniPathŎw肳ꂽinit@C̒lCX^X𐶐
     * @param iniPath init@Cւ̐΃pX
     */
    public IniFile(String iniPath) throws IOException
    , ParserConfigurationException, SAXException {
        init(iniPath);
    }
    
    /**
     * iniPathŎw肳ꂽini XMLt@Cǂݍ݁A
     * ̃CX^X
     * @param iniPath init@Cւ̐΃pX
     * @exception IOException XMLt@CIOG[ꍇ
     * @exception ParserConfigurationException p[T[̐Ɏsꍇ
     * @exception SAXException XMLt@C̃p[XŃG[ꍇ
     */
    public void init(String iniPath) throws IOException
    , ParserConfigurationException, SAXException {
        iniPath_ = iniPath;
        SAXParserFactory factory = SAXParserFactory.newInstance();
        XMLReader reader = factory.newSAXParser().getXMLReader();
        reader.setContentHandler(this);
        // XMLt@C̓ǂݍ݂Jn
        reader.parse(new File(iniPath_).toURL().toExternalForm());
    }
    
    /**
     * w肳ꂽZNṼGglԂB
     * w肳ꂽGgȂꍇnullԂ
     * @param sectionName ZNV
     * @param entryName Gg
     * @return Gg̒l
     */
    public String getEntry(String sectionName, String entryName) {
        Map section = (Map)root_.get(sectionName);
        
        // ZNV݂
        if (section != null) {
            // Gg̒lԂ
            return  (String)section.get(entryName);
        } else {
            return null;
        }
    }
    
    ////////////// ȉSAX2C^tF[X̎ //////////////
    
    /**
     * vf̊Jnʒm󂯎SAX2C^tF[X̎B
     * sectionvfƂMap𐶐
     * @param uri XMLt@CURI
     * @param localName OuCq܂܂Ȃ[Jvf
     * (OԏsȂꍇ͋󕶎)
     * @param qName OuCqvfC
     * @param attributes ̗vf
     */
    public void startElement(String uri, String localName
    , String qName, Attributes attributes) {
        current_ = qName;
        
        // sectionvfꂽꍇ
        if ("section".equals(current_)) {
            section_ = new HashMap();
            // nameL[ɂsectionp̃}bvۑ
            // nameȂ̂[0]Ōߑł
            root_.put(attributes.getValue(0), section_);
        } else if ("entry".equals(current_)) {
            // entryۑ
            entryName_ = attributes.getValue(0);
            entryValue_ = new StringBuffer();
        }
    }
    
    /**
     * vf̕f[^̒ʒm󂯎SAX2C^tF[X̎
     * entrỹeLXgobt@O
     * @param ch eLXgz
     * @param start z̊Jnʒu
     * @param length z񂩂gp镶
     */
    public void characters(char[] ch, int start, int length) {
        if ("entry".equals(current_)) {
            entryValue_.append(ch, start, length);
        }
    }
    
    /**
     * vf̏Iʒm󂯎SAX2C^tF[X̎
     * entry̒l}bvɐݒ肷
     * @param uri XMLt@CURI
     * @param localName OuCq܂܂Ȃ[Jvf
     * (OԏsȂꍇ͋󕶎)
     * @param qName OuCqvfC
     * @param attributes ̗vf
     */
    public void endElement(String uri, String localName, String qName) {
        if ("entry".equals(qName)) {
            // entrẙi[
            section_.put(entryName_, new String(entryValue_));
        }
    }
}
