package jp.ne.ytp.collection.practice;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 *  Kw̃L[Ƃ\ȃ}bv
 *  @author YTP
 */
public class MultiKeyMap {
    /**
     *  L[̊Kw
     */
    private final int layer_;
    
    /**
     *  ŏʊKw([g)Map
     */
    private Map root_ = new HashMap();
    
    /**
     *  layerŎw肳ꂽKwL[ƂĎCX^X𐶐
     *  CX^X́ÅKwύXłȂ
     */
    public MultiKeyMap(int layer) {
        layer_ = layer;
    }
    
    /**
     *  keysL[ƂāAvaluei[
     *  @param keys i[Ώۃf[^̃L[i[z
     *  @param value i[Ώۃf[^
     *  @exception IllegalArgumentException keys̗vfKwƈقȂꍇ
     */
    public void put(List keys, Object value) {
        // L[̊KwقȂꍇ
        if (keys.size() != layer_) {
            throw new IllegalArgumentException();
        }
        
        Map current = root_;
        int i = 0;
        
        // L[̐-1 
        for (; i < keys.size() - 1; i++) {
            Object lower = current.get(keys.get(i));
            
            // VKL[̏ꍇ
            if (lower == null) {
                Map newMap = new HashMap();
                
                // ̃x̃}bv`
                current.put(keys.get(i), newMap);
                // Jg̃}bṽxɉ
                current = newMap;
            } else {
                current = (Map)lower;
            }
        }
        
        // f[^̊i[
        current.put(keys.get(i), value);
    }
    
    /**
     *  f[^BȂꍇnullԂB
     *  keys(keys.size() - 1)z̃f[^邪A
     *  ŉw܂ŌĂL[Ȃꍇ́A
     *  ̎_ŌnullԂB
     *  ܂AL[̊Kw𒴂L[̐keysŎw肳ꂽꍇnullԂ
     *  @param keys Ώۂ̃L[i[z
     *  @return f[^
     */
    public Object get(List keys) {
        // Kwŉw𒴂ꍇ
        if (keys.size() > layer_) {
            return null;
        }
        
        Map current = root_;
        int i = 0;
        
        // L[̐-1 
        for (; i < keys.size() - 1; i++) {
            Object lower = current.get(keys.get(i));
            
            // L[Ȃꍇ
            if (lower == null) {
                return null;
            } else {
                current = (Map)lower;
            }
        }
        
        return current.get(keys.get(i));
    }
    
    /**
     *  keysŎw肳ꂽL[z(1Kw)MapێL[̈ꗗԂB
     *  ԂZbg͓NX̃}bvƘÂŁA
     *  Zbgɑ΂ύX̓}bvɔfB
     *  Zbgɑ΂锽̏Ƀ}bvύXꂽꍇǍʂ͕ۏ؂ȂB
     *  w̃L[ȂꍇnullԂB
     *  ܂AL[̊Kw-1𒴂L[̐keysŎw肳ꂽꍇnullԂ
     *  @param keys Ώۂ̃L[i[z
     *  @return L[̈ꗗ
     *  @see java.util.Map#keySet()
     */
    public Set keySet(List keys) {
        // Kwŉw-1𒴂ꍇ
        if (keys.size() > layer_ - 1) {
            return null;
        }
        
        Map target = (Map)this.get(keys);
        
        // Ώۂꍇ
        if (target != null) {
            return target.keySet();
        } else {
            return null;
        }
    }
    
    /**
     *  keysŎw肳ꂽL[z(1Kw)Mapێl̈ꗗԂB
     *  ԂRNV͓NX̃}bvƘÂŁA
     *  RNVɑ΂ύX̓}bvɔfB
     *  RNVɑ΂锽̏Ƀ}bvύXꂽꍇǍʂ͕ۏ؂ȂB
     *  w̃L[ȂꍇnullԂB
     *  ܂AL[̊Kw-1𒴂L[̐keysŎw肳ꂽꍇnullԂ
     *  @param keys Ώۂ̃L[i[z
     *  @return l̈ꗗ
     *  @see java.util.Map#values()
     */
    public Collection values(List keys) {
        // Kwŉw-1𒴂ꍇ
        if (keys.size() > layer_ - 1) {
            return null;
        }
        
        Map target = (Map)this.get(keys);
        
        // Ώۂꍇ
        if (target != null) {
            return target.values();
        } else {
            return null;
        }
    }
}
