package jp.ne.ytp.collection.reference.clazz;

import java.util.Iterator;
import java.util.WeakHashMap;

/**
 *  WeakHashMapNX̎gmFNX
 */
public class WeakHashMapTester {
	/**
	 * L[ƂȂNX
	 */
	class Key {
		/**
		 * URLȂ
		 */
		String name;
		/**
		 * nameŎw肳ꂽURLKvȏ_E[h
		 * i[Ȃ
		 */
		Object obj;

		public Key(String n) {
			name = n;
			obj = "object-"+n;
		}
		public Result calculate() {
			// ͕̏GŎԂ|Ƃ
			return new Result(obj);
		}
		public String toString() {
			return name;
		}
	}
	/**
	 * ۂɉʂ֕\f[^
	 */
	class Result {
		String data;
		public Result(Object o) {
			data = "Result[" + o.toString()+"]";
		}
		public String toString() {
			return data;
		}
	}
	/**
	 * L[ۂɉʂ֕\f[^NX
	 */
	class Factory {
		private WeakHashMap map = new WeakHashMap(5);
		public Result createResult(Key key) {
			Result obj = null;
			if (key == null) {
				/*
				 * ƂƑ݂ȂGg폜remove()
				 * \bhsĂ̂́AgĂȂ
				 * GgKx[WƂ鏈put()Aremove()A
				 * clear()\bhŎs邩łBȂ
				 * get()\bhł͎͂̏sȂ
				 */
				map.remove(null);
				return obj;
			}
			obj = (Result) map.get(key);
			if (obj == null) {
				obj = key.calculate();
				map.put(key, obj);
				System.out.println("vZ@:" + key + ":" + obj);
			} else {
				System.out.println("ėp:" + key + ":" + obj);
			}
			return obj;
		}
		public void info() {
			Runtime rt = Runtime.getRuntime();
			System.out.println("-------------------------------");
			System.out.println("JavaVM Free Memory:" + rt.freeMemory());
			System.out.println("map̗vf     :" + map.size());
			Iterator iterator = map.entrySet().iterator();
			while (iterator.hasNext()) {
				System.out.println(iterator.next());
			}
			System.out.println("");
		}
		public boolean isEmpty() {
			return map.isEmpty();
		}
	}
	/**
	 *  eXgs
	 */
	public void test() {
		Key[] keys = new Key[] {
			new Key("http://www.ytp.ne.jp/01.svg"),
			new Key("http://www.ytp.ne.jp/02.svg"),
			new Key("http://www.ytp.ne.jp/03.svg"),
			new Key("http://www.sssg.org/01.svg"),
			new Key("http://www.sssg.org/02.svg"),
		};
		Factory f = new Factory();
		// map͋
		f.info();
		// o^ĂȂKeyɑΉResult͌vZ
		System.out.println(f.createResult(keys[0]));
		f.info();
		// vZ
		System.out.println(f.createResult(keys[1]));
		f.info();
		// vZ
		System.out.println(f.createResult(keys[2]));
		f.info();
		/*
		 * xo^ĎQƂ𑱂ĂKeyɑΉResult
		 * ėpł
		 */
		System.out.println(f.createResult(keys[2]));
		f.info();
		// keys[0]ւ̎QƂȂ
		keys[0] = null;
		/*
		 * keys[0]ƑΉGgKx[Wɂ邽߂
		 * f.createResult(keys[0])܂f.createResult(null)
		 * s
		 */
		System.out.println(f.createResult(keys[0]));
		// IɃKx[WRNgs
		System.gc();
		// Kx[WRNgƗvf1
		f.info();
		// vZ
		System.out.println(f.createResult(keys[3]));
		f.info();
		// vZ
		System.out.println(f.createResult(keys[4]));
		f.info();
		// keys[0]Kx[WRNgĂvZs
		keys[0] = new Key("http://www.ytp.ne.jp/01.svg");
		System.out.println(f.createResult(keys[0]));
		System.gc();
		f.info();
		// ėp
		System.out.println(f.createResult(keys[4]));
		f.info();
		// ėp
		System.out.println(f.createResult(keys[3]));
		f.info();
		// L[̎QƂȂ
		for (int i=0 ; i<keys.length ; i++) {
			keys[i] = null;
		}
		/*
		 * IɃKx[WRNgJԂWeakHashMap̃Gg
		 * 邱ƂmF
		 */
		long count = 0;
		while (count++ < 1000 && !f.isEmpty()) {
			System.gc();
		}
		System.out.println("System.gc()Ă񂾉:" + count);
		// vfȂ
		f.info();
	}

	/**
	 * C\bh
	 * @param args R}hCp[^
	 */
	public static void main(String[] args) {
		new WeakHashMapTester().test();
	}
}
